function setUpVersions () {          
    const XPOINTER_SERVICE_CONTRACTID = "@mozilla.org/xpointer-service;1";
    var XPointerService = null;
    if (Components.classes[XPOINTER_SERVICE_CONTRACTID]) {
        XPointerService =
            Components.classes[XPOINTER_SERVICE_CONTRACTID].getService()
                 .QueryInterface(Components.interfaces.nsIXPointerService);
        if (XPointerService && XPointerService.getVersion) {
            document.getElementById ("xpointerLibVersion").setAttribute ("value", XPointerService.getVersion());
        } else if (XPointerService) {
            document.getElementById ("xpointerLibVersion").setAttribute ("value", "installed");
        }
    }

    const ANNOTATIONS_SERVICE_CONTRACTID = "@mozilla.org/annotations_service;1";
    var annotationsService = null;
    if (Components.classes[ANNOTATIONS_SERVICE_CONTRACTID]) {
        annotationsService =
            Components.classes[ANNOTATIONS_SERVICE_CONTRACTID].getService()
                .QueryInterface(Components.interfaces.nsIAnnotationsService);
        if (annotationsService && annotationsService.getVersion) {
            document.getElementById("annotationsServiceVersion").setAttribute ("value", annotationsService.getVersion());
        } else if (annotationsService) {
            document.getElementById("annotationsServiceVersion").setAttribute ("value", "installed");
        }
    }
}
